VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows-Standard
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.
'
' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

Private Sub Form_Load()
    Dim lstInfo     As ListBox
    Dim toc         As formated_toc
    Dim i           As Long
    Dim j           As Long
    Dim LBA         As Long
    Dim msf         As msf
    Dim strDrive    As String
    Dim btSector()  As Byte

    strDrive = InputBox("Bitte CD/DVD-ROM Laufwerksbuchstaben eingeben", , "E:")

    Me.Width = 4500
    Me.Height = 6000

    Set lstInfo = Controls.Add("VB.ListBox", "lstInfo")
    With lstInfo
        .Width = Me.ScaleWidth
        .Height = Me.ScaleHeight
        .Top = 0
        .Left = 0
        .Visible = True
    End With

    ' Test Unit Ready - auch von Festplatten untersttzt
    lstInfo.AddItem strDrive & " bereit: " & IsDriveReady(strDrive)

    ' Inquiry - auch von Festplatten untersttzt
    ' gibt Produktinfos zurck, u.a. Gertenamen
    lstInfo.AddItem strDrive & " Name: " & GetDriveName(strDrive)

    ' Unformatierte TOC (Table Of Contents) lesen.
    ' Vielleicht nicht von uralten Laufwerken
    ' (Baujahr < Ende 1999) untersttzt.
    toc = GetDriveTOC(strDrive)

    ' Prfen, ob TOC gelesen werden konnte
    If toc.toc_valid Then
        ' Anzahl an Sessions auf der CD
        lstInfo.AddItem "CD Sessions: " & toc.num_sessions
        ' Anzahl an Tracks auf der CD
        lstInfo.AddItem "CD Tracks: " & toc.num_tracks

        ' Gre der CD ber Adresse des
        ' Lead-Outs der letzten Session ermitteln
        With toc.sessions(toc.num_sessions - 1)
            With .tracks(.num_tracks)
                lstInfo.AddItem "CD Gre: " & (.start_lba * 2352) \ (1024 ^ 2) & " MB"
            End With
        End With

        lstInfo.AddItem ""

        For i = 1 To toc.num_sessions
            With toc.sessions(i - 1)
                ' Session Info
                lstInfo.AddItem ">> Session " & Format(.session, "00")
                lstInfo.AddItem ">>>> Tracks: " & .num_tracks

                lstInfo.AddItem ""

                ' Info zu jedem Track in der Session
                For j = 0 To .num_tracks - 1
                    With .tracks(j)
                        lstInfo.AddItem ">>>> Track " & Format(.track, "00")
                        lstInfo.AddItem ">>>> Audio: " & .audio
                        lstInfo.AddItem ">>>> Start: " & .start_lba & _
                            " LBA (" & msf_to_str(.start_msf) & " MSF)"
                        LBA = .start_lba
                    End With

                    ' Der letzte Eintrag in tracks() steht fr das Lead-Out.
                    ' Track Gre = LBA(Track + 1) - LBA(Track)
                    LBA = .tracks(j + 1).start_lba - LBA
                    lstInfo.AddItem ">>>> Lnge: " & LBA & _
                        " LBA (" & msf_to_str(lba_to_msf(LBA)) & " MSF)"
                    lstInfo.AddItem ">>>> Gre: " & (LBA * 2352) \ (1024 ^ 2) & " MB"
                    lstInfo.AddItem ""
                Next
            End With
        Next
    Else
        lstInfo.AddItem "Konnte TOC nicht lesen"
    End If

    lstInfo.AddItem ""

    ' 1 Sektor im Raw Modus lesen, heit, den Sektor komplett
    ' (ohne Sub Channels) auslesen. 1 Sektor ist 2352 Bytes gro.
    '
    ' Wrde man nur die Userdaten eines Mode-1 (Daten) Sektors
    ' auslesen wollen, msste man den Buffer 2048 Bytes gro machen
    ' (und die Flags natrlich auf Userdata stellen).
    ReDim btSector(2352 - 1) As Byte

    ' Sektor 16 auslesen, bei ISO9660 Daten CDs ist das der erste
    ' Sektor es Dateisystems. Das Maximum sind knapp 26 Sektoren fr RAW,
    ' da der jeweilige Treiber meistens nicht mehr als 65536 Bytes pro
    ' Befehl aufnehmen kann.
    '
    ' Einen kompletten Track knnte man in
    ' Verbindung mit den LBA Zahlen der TOC auslesen.
    '
    ' Viele alte Laufwerke produzieren beim Auslesen von Audio Tracks
    ' Fehler, da diesen im Gegensatz zu Datentracks ein Synchronisationsmuster fehlt.
    ' Im Internet finden sich verschiedene Verfahren (Jitter Korrektur),
    ' um solche Fehler auszubgeln. Einige ltere Laufwerke untersttzen den
    ' READ CD OpCode auch nicht, da msste man auf READ10 oder READ12
    ' ausweichen, die aber AFAIK nur Daten Tracks auslesen knnen.
    '
    ' Fr mehr Infos zu READ CD die MMCs durchblttern!
    If GetDriveSectors(strDrive, 16, 1, RD_RAW, VarPtr(btSector(0)), 2352) Then
        lstInfo.AddItem "Erfolgreich Sektor 16 Raw gelesen!"
        Debug.Print StrConv(btSector, vbUnicode)
    Else
        lstInfo.AddItem "Konnte Sektor 16 nicht auslesen!"
    End If
End Sub
